#using <mscorlib.dll>

#ifndef PICTUREINFO
#define PICTUREINFO

using namespace System;

namespace HongliangSoft {
  namespace Utilities {
    public __gc class PictureInfo {
    private:
      long x, y, width, height;
      int hResolution, vResolution;
      int colorDepth;
      String* info;
    private public:
      PictureInfo(long x, long y, long width, long height, WORD hRes, WORD vRes, short color, String* info) {
        this->x = x;
        this->y = y;
        this->width = width;
        this->height = height;
        this->hResolution = hRes;
        this->vResolution = vRes;
        this->colorDepth = color;
        this->info = info;
      }
    public:
      __property long get_X() { return this->x; }
      __property long get_Y() { return this->y; }
      __property long get_Width() { return this->width; }
      __property long get_Height() { return this->height; }
      __property int get_HorizontalResolution() { return this->hResolution; }
      __property int get_VerticalResolution() { return this->vResolution; }
      __property int get_ColorDepth() { return this->colorDepth; }
      __property String* get_Information() { return (this->info == NULL) ? S"" : this->info; }
    };
  }
}
#endif