#ifndef UNMANAGED
#define UNMANAGED

#include <windows.h>
#include <time.h>
#include "SusieError.h"
#include "ProgressCallback.h"
typedef struct {
  long left, top, width, height;
  WORD hRes, vRes;
  short colorDepth;
  HLOCAL info;
} PICTINFO;
typedef struct {
  unsigned char method[8];        /* k@̎ */
  unsigned long position;         /* t@Cł̈ʒu */
  unsigned long compsize;         /* kꂽTCY */
  unsigned long filesize;         /* ̃t@CTCY */
  time_t timestamp;               /* t@C̍XV */
  char path[200];                 /* ΃pX */
  char filename[200];             /* t@Cl[ */
  unsigned long crc;              /* CRC */
} FILEINFO;

#include "SusieError.h"
#include "ProgressCallback.h"

typedef HongliangSoft::Utilities::SusieError (PASCAL *IsSupportedHandler)(LPSTR filePath, DWORD fileHandleOrBuffer);

typedef int (PASCAL *GetPluginInfoHandler)(int type, LPSTR buffer, int bufferSize);

typedef HongliangSoft::Utilities::SusieError (PASCAL *GetPictureInfoHandler)(void* filePathOrImageAddress, long offsetOrSize, UINT fromFileOrMemory, PICTINFO* info);

typedef HongliangSoft::Utilities::SusieError (PASCAL *GetPictureHandler)(void* filePathOrImageAddress, long offsetOrSize, UINT fromFileOrMemory, HLOCAL* bitmapInfo, HLOCAL* bitmapData, HongliangSoft::Utilities::ProgressCallback* callback, long dataForCallback);

typedef HongliangSoft::Utilities::SusieError (PASCAL *ConfigurationDlgHandler)(HWND ownerWindow, int functionCode);

typedef HongliangSoft::Utilities::SusieError (PASCAL *GetArchiveInfoHandler)(void* filePathOrArchiveAddress , long offsetOrSize, UINT fromFileOrMemory, HLOCAL* infos);

typedef HongliangSoft::Utilities::SusieError (PASCAL *GetFileInfoHandler)(void* filePathOrArchiveAddress, long offsetOrSize, LPSTR fileNameInArchive, UINT flags, FILEINFO* info);

typedef HongliangSoft::Utilities::SusieError (PASCAL *GetFileHandler)(void* filePathOrArchiveAddress, long offsetOrSize, void* outputDirectoryOrResultAddress, UINT flags, HongliangSoft::Utilities::ProgressCallback* callback, long dataForCallback);

#define FROM_FILE            0x0000
#define FROM_MEMORY          0x0001
#define SHOW_ABOUT_DIALOG    0x0000
#define SHOW_CONFIG_DIALOG   0x0001
#define CASE_SENSITIVE       0x0000
#define IGNORE_CASE          0x0080
#define TO_FILE              0x0000
#define TO_MEMORY            0x0100

static int PASCAL NoProcess(int count, int countMax, long data) {
  return 0;
}
#endif